---
title: Ruby on Rails 环境及准备
layout: post
category: ruby
---

## 用户

### 新建用户
```bash
# 新建一个用户
useradd -m -s /usr/bin/zsh webuser

# 设置密码
passwd webuser
```

### 将用户放到sudoers列表

编辑文件 `/etc/sudoers` 文件, 增加`webuser ALL=(ALL:ALL) ALL`


## 安装依赖及工具

### 常用工具
* `git` 版本管理
* `curl` 利用URL语法在命令行方式下工作的文件传输工具。
* `clang` c的轻量级编译器，也可以编译C++、Objective C、Objective C++等，相对于gcc和g++性能更好。
* `make` 构建工具，配置文件在Makefile
* `nodejs`
* `openssl` 为网络通信提供安全及数据完整性的一种安全协议
* `nginx`

## 数据库
* `mysql-server` 最新版本的mysql数据库
* `postgresql`

## 常用lib

* `libssl-dev` openssl库，ssl安全协议
* `libreadline6-dev`  readline库，命令行文本编辑
* `zlib1g-dev` 数据压缩，zlib
* `libyaml-dev` yaml 解析， nokogiri dependencies
* `libxml2-dev` GNOME XML library，xml支持
* `libxslt1-dev` XSLT 1.0 processing library

## Ruby 依赖库



## Gems 依赖库

* pg: libpq-dev
* mysql2: `libmysqlclient-dev`
* sqlite3: `libsqlite3-dev`
* passenger: libcurl4-openssl-dev


### tk图形库
- `tklib`

## 安装`rbenv` & `ruby`

## 安装bundler

```bash
gem install -N bundler
```
