---
layout: post
title: 我们应该如何做自己的B2C？
published: false
---

# 企业产品展示（销售）型官网项目


 建一个企业官网很简单，但是建一个好的企业官网不简单。
 比较有用户体验的帮助优化和竞价转化的内容；


### 技术框架

- Ruby >= 1.9.3
- Rails >= 4.0
- jQuery >= 1.9
- Bootstrap 3.0


# 网站功能介绍

### 产品·服务模块

- 适用场景：提供产品或服务（难道有不提供产品或服务的企业么？）
- 网站功能：
产品服务展示；
在线预约、销售（无购物车功能）；
去淘宝支付；
在线咨询（配合企业QQ、商务通、百度商桥等使用）；

- 创新点：
每一个产品和服务总是由相应的“零件”组成的，产品描述也是由若干个“产品零件”的描述构成。
互联网作为一种信息传递工具，目的就是让消费者对产品服务有更深入的了解。采用“零件式”描述能够让消费者更容易理解产品，同时也使得产品描述更加规范化和简便。
两种展示形式：经典形式包含产品主页、产品分类列表（卡片式、列表式）、详情页；表格对比形式是得益于对产品的零件式分解，对于提供单一服务不同套餐的服务，可以通过表格对比形式展示产品。


### 客户服务模块
- 使用场景：客户咨询、售后服务（有客户存在，就有客户服务存在）
- 网站功能：
- 创新点：根据用户的特点推荐产品的分析技术；


### 产品及行业知识模块
- 使用场景：帮助用户更好的使用产品和服务，以及SEO
- 创新点：结构化而非词条形式的百科编辑及管理功能



# 为什么要自建官网

- 传统企业的互联网模式：任何行业，传统销售的总份额正在越来越低，线上销售的总份额越来越高，线上销售正在挤压传统销售渠道的份额。

- 不依赖电商平台：2012年百度搜索引擎算法大规模调整，过于依赖百度的大量私立医疗机构网络销售大幅下降，被迫缩小或砍掉互联网营销部门。2011年开始，天猫商城独立，淘宝将大部分流量引入天猫。淘宝C店业绩大规模下滑，一年间C店减少几百万家，下降27%。
  依赖平台始终无法凸显自己的品牌优势，是一种投机和饮鸩止渴的方式。总之就是，强势的始终是平台，平台就像赌场，不赚钱的商家总是多于赚钱的商家，而平台和庄家是始终的赢家。

- 离消费者更近：没有任何一个时代，让厂家（服务商）离消费者如此之近，代理商（淘宝C店）的优势一去不复返。线上销售的解决方案成本将越来越低，任何传统企业可以拓展自己的线上销售。

- 更大的发挥空间：通过天猫商城等销售平台很容易触及销售额天花板。企业自行拓展线上销售是新的增长机会。自建官网是对线上其他渠道的一个补充。


# 不同类型服务的电子商务策略
- 二次消费比例越高，在服务和维护上多下功夫。二次消费比例低的产品，在与客户沟通上多下功夫。










